#include <bits/stdc++.h>
using namespace std;

/* TYPES  */
#define ll long long

/* FUNCTIONS */
#define f(i,s,e) for(long long int i=s;i<e;i++)
#define cf(i,s,e) for(long long int i=s;i<=e;i++)
#define rf(i,e,s) for(long long int i=e-1;i>=s;i--)
#define pb push_back
#define eb emplace_back

/* PRINTS */
template <class T>
void print_v(vector<T> &v) { cout << "{"; for (auto x : v) cout << x << ","; cout << "b}"; }
template <class Type>
void print_arr(Type arr, int len)
{ for(int i=0;i<len;i++) cout << arr[i] << " ";
  cout << endl; }

/* UTILS */
#define MOD 1000000007
#define PI 3.1415926535897932384626433832795
#define read(type) readInt<type>()
ll min(ll a,int b) { if (a<b) return a; return b; }
ll min(int a,ll b) { if (a<b) return a; return b; }
ll max(ll a,int b) { if (a>b) return a; return b; }
ll max(int a,ll b) { if (a>b) return a; return b; }
ll gcd(ll a,ll b) { if (b==0) return a; return gcd(b, a%b); }
ll lcm(ll a,ll b) { return a/gcd(a,b)*b; }
string to_upper(string a) { for (int i=0;i<(int)a.size();++i) if (a[i]>='a' && a[i]<='z') a[i]-='a'-'A'; return a; }
string to_lower(string a) { for (int i=0;i<(int)a.size();++i) if (a[i]>='A' && a[i]<='Z') a[i]+='a'-'A'; return a; }
bool prime(ll a) { if (a==1) return 0; for (int i=2;i<=round(sqrt(a));++i) if (a%i==0) return 0; return 1; }
void yes() { cout<<"YESn"; }
void no() { cout<<"NOn"; }

/*  All Required define Pre-Processors and typedef Constants */
typedef long int int32;
typedef unsigned long int uint32;
typedef long long int int64;
typedef unsigned long long int  uint64;

const int MAXN=1015;
const int MAXM=1015;

int n,m,q,x,y;
vector<vector<ll>> a(MAXN);

int main()
{
  ios_base::sync_with_stdio(false);
  cin.tie(NULL);

  cin >> n >> m;

  for(int i=0;i<n;i++) for(int j=0;j<m;j++) { 
    int x;
    cin >> x;
    a[i].push_back(x);
  }

  cin >> q;

  // DP resenje za 40/100
  // PROBAJ DA OPTIMIZUJES, BEZ PONOVNOG SKLAPANJA DP-a
  while(q--) {
    cin >> x >> y;
    vector<vector<ll>> dp(n, vector<ll>(m,0));

    dp[0][0] = a[0][0];
    dp[x-1][y-1] = 1000;
    for(int i=1;i<m;i++) {
      if(dp[0][i] == 1000) {continue;}
      dp[0][i] = dp[0][i-1]+a[0][i];
    }

    for(int i=1;i<n;i++) {
      if(dp[i][0] == 1000) continue;
      dp[i][0] = dp[i-1][0]+a[i][0];
    }


    // ispuniti ostatak dp-a
    for(int i=1;i<n;i++) {
      for(int j=1;j<m;j++) {
        // if(i==x && j==y) continue;
        if(dp[i][j]==1000) continue;
        dp[i][j] = a[i][j]+min(dp[i][j-1], dp[i-1][j]);
      }
    }

    // for(auto x : dp) {
      // for(auto y : x) {
        // cout << y << " ";
      // }
      // cout << "\n";
    // }
    
    cout << dp[n-1][m-1] << "\n";
  }

  return 0;
}